shakespeare-2.0.7: A toolkit for making compile-time interpolated templates

Safe Haskell | None
Language | Haskell98

Text.Shakespeare.Base

Description

General parsers, functions and datatypes for all Shakespeare languages.

# Documentation

data Deref Source

Constructors

DerefModulesIdent [String] Ident |
DerefIdent Ident |
DerefIntegral Integer |
DerefRational Rational |
DerefString String |
DerefBranch Deref Deref |
DerefList [Deref] |
DerefTuple [Deref] |

Instances

Eq Deref Source |
Data Deref Source |
Ord Deref Source |
Read Deref Source |
Show Deref Source |
Lift Deref Source |

newtype Ident Source

Constructors

Ident String |

Instances

Eq Ident Source |
Data Ident Source |
Ord Ident Source |
Read Ident Source |
Show Ident Source |
Lift Ident Source |

type Scope = [(Ident, Exp)] Source

parseDeref :: UserParser a Deref Source

parseHash :: UserParser a (Either String Deref) Source

parseVar :: Char -> UserParser a (Either String Deref) Source

parseVarString :: Char -> UserParser a (Either String String) Source

parseAt :: UserParser a (Either String (Deref, Bool)) Source

parseUrl :: Char -> Char -> UserParser a (Either String (Deref, Bool)) Source

parseUrlString :: Char -> Char -> UserParser a (Either String String) Source

parseCaret :: UserParser a (Either String Deref) Source

parseUnder :: UserParser a (Either String Deref) Source

parseInt :: Char -> UserParser a (Either String Deref) Source

parseIntString :: Char -> UserParser a (Either String String) Source

derefToExp :: Scope -> Deref -> Exp Source

flattenDeref :: Deref -> Maybe [String] Source

readUtf8File :: FilePath -> IO Text Source